/* ========================================================================
 *                                ERNDMCON.H
 * ------------------------------------------------------------------------
 *  Instantiations of the MultConRandGen class.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( ERNDMCON_H )
  #define ERNDMCON_H

  #if !defined( RANDMCON_H )
    #include "randmcon.h"
  #endif

/* ------------------------------------------------------------------------
 *  The Generators which follow were taken from Knuth Vol 2, Section 3.3.4
 *  from a list of RNGs that passed the Spectral test.
 */


  class  BoroshNiederreiterRandGen : public MultConRandGen
   {
  public:
    EXPLICIT BoroshNiederreiterRandGen( size_rand seed=1 ) :
       MultConRandGen( 1812433253UL, seed )
     { }
   } ;



  class  WatermanRandGen : public MultConRandGen
   {
  public:
    EXPLICIT WatermanRandGen( size_rand seed=1 ) :
       MultConRandGen( 1566083941UL, seed )
     { }
   } ;
   

   
  class  MarsagliaMCRandGen : public MultConRandGen
   {
  public:
    EXPLICIT MarsagliaMCRandGen( size_rand seed=1 ) :
       MultConRandGen( 69069UL, seed )
     { }
   } ;
   


  class  LavauxJanssensRandGen : public MultConRandGen
   {
  public:
    EXPLICIT LavauxJanssensRandGen( size_rand seed=1 ) :
       MultConRandGen( 1664525UL, seed )
     { }
   } ;
   
#endif
