/* ========================================================================
 *                                ERNDSECM.H
 * ------------------------------------------------------------------------
 *  Instantiations of SecConModRandGen.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( ERNDSECM_H )
  #define ERNDSECM_H

  #if !defined( RANDSECM_H )
    #include "randsecm.h"
  #endif

/* -------------------------------------------------------------------------
 * The following PRNGs are taken from Knuth Vol 2. in the Spectral test
 *  table, Section 3.3.4
 *
 */

 class Knuth28RandGen : public SecConModRandGen
  {
 public:
   EXPLICIT Knuth28RandGen( size_rand seed=1 ) :
    SecConModRandGen( 0x7fffffffUL-314159269L, 271828183L, 0UL, 0x7fffffffUL,
                       seed )
    { }
  } ;


#endif
