/* =========================================================================
 *                             RANDDIFF.CPP
 * -------------------------------------------------------------------------
 *  Implementation file for a Random Number gererator that subtracts one
 *  generator's output from another.  Based on article in June 1995
 *  C/C++ User's Journal by Jerry Dwyer.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#include "environ.h"

#include _STRSTREAM_HEADER

#include "randdiff.h"




DIFFRET(RandomGenerator,DifferenceRandGen)
                                     *DifferenceRandGen::ReCreate( void ) const
 {
  return new DifferenceRandGen( pRandGenX()->ReCreate(),
                                pRandGenY()->ReCreate() );
 }



size_rand   DifferenceRandGen::Number( void )
 {
  size_rand  rand1, rand2;

  rand1 = pRandGenX()->Number();
  rand2 = pRandGenY()->Number();

  if(rand1 < rand2)
   {
    rand1 += pRandGenY()->MaxRandom();
   }

  return (rand1 - rand2);
 }
