/* =========================================================================
 *                               RANDDIFF.H
 * -------------------------------------------------------------------------
 *  Interface file for a Random Number gererator that subtracts one
 *  generator's output from another.  Based on article in June 1995
 *  C/C++ User's Journal by Jerry Dwyer.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( RANDDIFF_H )
  #define  RANDDIFF_H

  #if !defined( RANDGEN_H )
    #include "randgen.h"
  #endif
  #if !defined( RANDCOMB_H )
    #include "randcomb.h"
  #endif


  class  DifferenceRandGen : public CombineRandGen
   {
  private:
    // protect the = operator and copy constructor so they cannot be used.
    DifferenceRandGen& operator=( DifferenceRandGen const & );
    DifferenceRandGen( DifferenceRandGen const & );

  public:
    DifferenceRandGen( RandomGenerator *pGenX, RandomGenerator *pGenY ) :
      CombineRandGen(pGenX,pGenY) { }
    virtual   ~DifferenceRandGen() { }

    virtual DIFFRET(RandomGenerator,DifferenceRandGen)  *ReCreate( void ) const;

    virtual  size_rand   MaxRandom( void ) const
     {
      return max(pRandGenX()->MaxRandom(),pRandGenY()->MaxRandom());
     }

    virtual  size_rand   Number( void );
   } ;

#endif
