/* =========================================================================
 *                                 RANDICON.CPP
 * -------------------------------------------------------------------------
 *  Implementation file for any inverse congruential pseudo-random number
 *  generator with a prime modulus. As described in Andreas Weingartner's
 *  Master's thesis.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#include "environ.h"
#include "randicon.h"
#include "modarith.h"



DIFFRET(RandomGenerator,InvConModRandGen)
                                     *InvConModRandGen::ReCreate( void ) const
 {
  return new InvConModRandGen( Multiplier(), Increment(), Modulus(), Seed() );
 }



size_rand    InvConModRandGen::Number( void )
 {
  SetCurrSeed( mod_add( mod_mult( Multiplier(), InvertSeed(), Modulus() ),
                        Increment(), Modulus() ) );

  return CurrSeed();
 }




size_rand    InvConModRandGen::InvertSeed( void ) const
 {
  return mod_invert( CurrSeed(), Modulus() );
 }
