/* =========================================================================
 *                                 RANDLCON.CPP
 * -------------------------------------------------------------------------
 *  Implementation file for any linear congruential pseudo-random number 
 *  generator with a modulus of 2^32 as an object.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#include "environ.h"
#include "randlcon.h"



DIFFRET(RandomGenerator,LinConRandGen)  *LinConRandGen::ReCreate( void ) const
 {
  return new LinConRandGen( Multiplier(), Increment(), Seed() );
 }



size_rand    LinConRandGen::Number( void )
 {
  SetCurrSeed( Multiplier() * CurrSeed() + Increment() );
  return CurrSeed();
 }
