/* =========================================================================
 *                                 RANDNTBL.CPP
 * -------------------------------------------------------------------------
 *  Implementation file for a number table driven pseudo-random number
 *  generator as an object.  (Assumes table on disk.)
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#include <ctype.h>
#include "environ.h"

#include _FSTREAM_HEADER

#include "randntbl.h"




DIFFRET(RandomGenerator,NumberTableRandGen)
                                    *NumberTableRandGen::ReCreate( void ) const
 {
  return new NumberTableRandGen( FileName(), Start() );
 }



size_rand    NumberTableRandGen::Number( void )
 {
  ifstream   &is = Table();
  size_rand   number;

  if(!is)
    return 0;

  is >> ws >> number;

  if(is.eof())
    InitTable();

  return number;
 }
