/* =========================================================================
 *                                 RANDNTBL.H
 * -------------------------------------------------------------------------
 *  Interface file for a number table driven random number generator
 *  as an object.
 *  (Assumes that the table resides on disk.)
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( RANDNTBL_H )
  #define RANDNTBL_H

  #if !defined( ENVIRON_H )
    #include "environ.h"
  #endif
  #include _FSTREAM_HEADER
  #if !defined( RANDGEN_H )
    #include "randgen.h"
  #endif
  #if !defined( RANDTABL_H )
    #include "randtabl.h"
  #endif


  class  NumberTableRandGen : public TextTableRandGen
   {
  private:
    // protect the = operator and copy constructor so they cannot be used.
    NumberTableRandGen& operator=( NumberTableRandGen const & );
    NumberTableRandGen( NumberTableRandGen const & );

  public:
    EXPLICIT NumberTableRandGen( const char *szFileName, streampos start=0 ) :
      TextTableRandGen( szFileName, start ) { }
    virtual   ~NumberTableRandGen() { }
 
    virtual DIFFRET(RandomGenerator,NumberTableRandGen)
                                                       *ReCreate( void ) const;

    virtual  size_rand   Number( void );
   } ;


#endif
