/* =========================================================================
 *                                 RANDSECM.CPP
 * -------------------------------------------------------------------------
 *  Implementation file for any second-order congruential pseudo-random number
 *  generator as an object.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#include <math.h>
#include "environ.h"

#include "randsecm.h"
#include "modarith.h"




DIFFRET(RandomGenerator,SecConModRandGen)
                                     *SecConModRandGen::ReCreate( void ) const
 {
  return new SecConModRandGen( MultLast(), MultCurr(), Increment(), Modulus(),
                                Seed()
                              );
 }




size_rand    SecConModRandGen::Number( void )
 {
  size_rand  newSeed;

  newSeed = mod_add( mod_mult( MultCurr(), CurrSeed(), Modulus() ),
                     mod_mult( MultLast(), LastSeed(), Modulus() ),
                     Modulus()
                   );
  newSeed = mod_add( newSeed, Increment(), Modulus() );

  SetLastSeed( CurrSeed() );
  SetCurrSeed( newSeed );

  return CurrSeed();
 }
