/* =========================================================================
 *                                 RNDLCONM.CPP
 * -------------------------------------------------------------------------
 *  Implementation file for any linear congruential pseudo-random number 
 *  generator as an object.
 *
 *  Version 0.9
 *
 *  Copyright 1995-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#include <math.h>

#include "environ.h"
#include "rndlconm.h"
#include "modarith.h"



DIFFRET(RandomGenerator,LinConModRandGen)
                                     *LinConModRandGen::ReCreate( void ) const
 {
  return new LinConModRandGen( Multiplier(), Increment(), Modulus(), Seed() );
 }




size_rand    LinConModRandGen::Number( void )
 {
  SetCurrSeed( mod_add( mod_mult( Multiplier(), CurrSeed(), Modulus() ),
               Increment(), Modulus() ) );

  return CurrSeed();
 }
