/* =========================================================================
 *                                rndlfibm.CPP
 * -------------------------------------------------------------------------
 *  Implementation file for Lagged Fibonacci random number generator with
 *  an arbitrary modulus as an object.
 *
 *  Version 0.9
 *
 *  Copyright 1996-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#include "environ.h"
#include "rndlfibm.h"
#include "modarith.h"



LaggedFibonacciModRandGen::LaggedFibonacciModRandGen( unsigned lower,
                                                      unsigned upper,
                                                      size_rand mod,
                                                      RandomGenerator *pRng )
 : LaggedFibonacciRandGen(lower,upper,pRng), myModulus(mod)
 { }



LaggedFibonacciModRandGen::~LaggedFibonacciModRandGen( void )
 { }


//  This is where the rest of the functionality is defined.


size_rand   LaggedFibonacciModRandGen::Number( void )
 {
  size_rand  RandNum = mod_add( LowValue(), HighValue(), Modulus() );

  IncrTaps();
  SetNewElement( RandNum );

  return RandNum;
 }
