/* =========================================================================
 *                                 RNDLFIBM.H
 * -------------------------------------------------------------------------
 *  Interface file for Lagged Fibonacci random number generator with an
 *  arbitrary modulus as an object.
 *
 *  Version 0.9
 *
 *  Copyright 1996-1997 by G. Wade Johnson
 *   Use of this code is placed in the public domain as long as the
 *   copyright notice is retained.
 */

#if !defined( RNDLFIBM_H )
  #define RNDLFIBM_H

  #if !defined( RANDLFIB_H )
    #include "randlfib.h"
  #endif


  class  LaggedFibonacciModRandGen : public LaggedFibonacciRandGen
   {
  private:
    const unsigned long   myModulus;

  private:
    // protect the = operator and copy constructor so they cannot be used.
    LaggedFibonacciModRandGen& operator=( LaggedFibonacciModRandGen const & );
    LaggedFibonacciModRandGen( LaggedFibonacciModRandGen const & );

  protected:
    // access methods for private data.
    unsigned long   Modulus() const { return myModulus; }

  public:
    LaggedFibonacciModRandGen( unsigned lower, unsigned upper,
                                   unsigned long mod, RandomGenerator *pRng );
    virtual   ~LaggedFibonacciModRandGen();

    virtual DIFFRET(RandomGenerator,LaggedFibonacciModRandGen)
                                                        *ReCreate( void ) const
     {
      return new LaggedFibonacciModRandGen( LowerTap(), UpperTap(), myModulus,
                                         Initializer()->ReCreate() );
     }

    virtual  size_rand   Number( void );
   } ;

#endif
